<?php
   /*
   Plugin Name: SoreThumb+ with PageLaser
   Plugin URI: http://sore-thumb.net/sorethumb-walkthrough/
   Description: Your visitors just can't ignore it! 
   Version: 1.6
   Author: 3Dolla
   Author URI: http://3dolla.com
   Slug: sorethumb
   */
//////////////////////////////////////////////////////////////////////////////
// Important!
//////////////////////////////////////////////////////////////////////////////
function stpv3_requires_wordpress_version() {
	global $wp_version;
	$plugin = plugin_basename( __FILE__ );
	$plugin_data = get_plugin_data( __FILE__, false );
	if ( version_compare($wp_version, "3.3", "<" ) ) {
		if( is_plugin_active($plugin) ) {
			deactivate_plugins( $plugin );
			wp_die( "'".$plugin_data['Name']."' requires WordPress 3.3 or higher, and has been deactivated! Please upgrade WordPress and try again.<br /><br />Back to <a href='".admin_url()."'>WordPress admin</a>." );
		}
	}
}
add_action( 'admin_init', 'stpv3_requires_wordpress_version' );
  define( 'SORETHUMB_PATH', plugin_dir_path(__FILE__) );
  define( 'SORETHUMB_URL', plugin_dir_url(__FILE__) );
  $PLUGINURL = SORETHUMB_URL;
  require_once SORETHUMB_PATH . 'includes/SmartMetaBox.php';
  $stpv3options = get_option('stpv3_options');
  include SORETHUMB_PATH . 'includes/pak/pakdef.php';
if (!class_exists('V3Notify')) {
    include SORETHUMB_PATH . 'includes/v3a.php';
    register_activation_hook( __FILE__, array( 'V3Notify', 'v3a_add_defaults' ) );
    }


//////////////////////////////////////////////////////////////////
// Install Operations
//////////////////////////////////////////////////////////////////
  global $sorethumb_db_version;
  
  $sorethumb_db_version = "1.6";
  
  function sorethumb_install() {
     global $wpdb;
     global $sorethumb_db_version;
     require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
     dbDelta($sql);
     add_option("sorethumb_db_version", $sorethumb_db_version);
  }

//////////////////////////////////////////////////////////////////
// Load Scripts and Styles
//////////////////////////////////////////////////////////////////
function sorethumb_scripts() {
 if(!is_admin()){ 
    wp_enqueue_script('jquery');
   // wp_enqueue_script('stpv3content', SORETHUMB_URL . 'includes/js/stpanim.js', array('jquery'));
      }
}

//function stpv3_conditionals() {
//if(!is_admin()){
//    echo '<!--[if IE 9]><script src="' . SORETHUMB_URL . 'includes/js/ie/sylvester.js" type="text/javascript"></script>
//    <script src="' . SORETHUMB_URL . 'includes/js/ie/transformie.js" type="text/javascript"></script><![endif]-->';
//  }
//}
  
function sorethumb_footerscripts(){
$options = get_option('stpv3_options');
$interval_site = $options['site_interval'];
$delay_site = $options['site_delay'];
$siteOn = $options['enable_sorethumb_site']; 
     echo '<script type="text/javascript" src="' . SORETHUMB_URL . 'includes/js/waypoints.min.js"></script>';
    echo '<script type="text/javascript" src="' . SORETHUMB_URL . 'includes/js/jquery-timing.min.js"></script>';
    echo '<script type="text/javascript" src="' . SORETHUMB_URL . 'includes/js/wiggle.jquery.js"></script>';
    
    if ($siteOn == 'enabled') {
    if ($options['site_element_1']) {
    echo '<script>';
    ?>
    
     jQuery(document).ready(function($) {

    $('<?php echo $options['site_element_1']; ?>').each(function(){
        $(this).wrap('<div class="stpAnimSite" rel="<?php echo $options['site_element_1_effect']; ?>" />');
    });         
});   </script>
    <?php
    }
    if ($options['site_element_2']) {
    echo '<script>';
    ?>
     jQuery(document).ready(function($) {

    $('<?php echo $options['site_element_2']; ?>').each(function(){
        $(this).wrap('<div class="stpAnimSite" rel="<?php echo $options['site_element_2_effect']; ?>" />');
    });         
}); </script>
    <?php
    }
    if ($options['site_element_3']) {
    echo '<script>';
    ?>
     jQuery(document).ready(function($) {

    $('<?php echo $options['site_element_3']; ?>').each(function(){
        $(this).wrap('<div class="stpAnimSite" rel="<?php echo $options['site_element_3_effect']; ?>" />');
    });         
}); 
 </script>
     <?php
     
     if(!$interval_site) {
       $interval_site = 1;
     }
    if(!$delay_site) {
       $delay_site = 2000;
     }
     
    }
echo '<script>';  
 ?>    jQuery(document).ready(function($) {
 
        function doAnimSite() { 
        $('div.stpAnimSite').each($).wait(<?php echo $interval_site; ?>, function(index){
         if ($.browser.msie) {
           $(this).wiggle('start', {
           limit: 5,
           randomStart: true, });
           } else {

            var animClass = $(this).attr('rel');
            $(this).addClass(animClass);
        var wait = window.setTimeout( function(){
            $('div.stpAnimSite').removeClass(animClass)},
            1300
        );
       }
      });
      }
    
                               
                setInterval(function() {   
                   doAnimSite();
                  }, <?php echo $delay_site; ?>);   
       
});


 </script>
    <?php
    }


if (!is_admin()) {
$interval_single = stpv3MetaBox::get('stpv3_interval');
$delay_single = stpv3MetaBox::get('stpv3_delay');
$enabled_single = stpv3MetaBox::get('stpv3_activate');

if($enabled_single) {
echo '<script>';
?>

jQuery(document).ready(function($) {

    $('span.stp').each(function(){
    if ($(this).children().hasClass('aligncenter')) {
            $(this).addClass('aligncenter');
        }
            if ($(this).children().hasClass('alignright')) {
            $(this).addClass('alignright');
        }
            if ($(this).children().hasClass('alignleft')) {
            $(this).addClass('alignleft');
        }
            if ($(this).children().hasClass('alignnone')) {
            $(this).addClass('alignnone');
        }
        $(this).children('img').css('max-width', 'none');
        $(this).wrap('<div class="stpAnim" />');
    });
    
        $('div.stpAnim').each(function(){
    if ($(this).children().hasClass('aligncenter')) {
            $(this).addClass('aligncenter');
        }
            if ($(this).children().hasClass('alignright')) {
            $(this).addClass('alignright');
        }
            if ($(this).children().hasClass('alignleft')) {
            $(this).addClass('alignleft');
        }
            if ($(this).children().hasClass('alignnone')) {
            $(this).addClass('alignnone');
        }
    });

<?php if(stpv3MetaBox::get('stpv3_trigger') == 'delay') {  ?>
    
        function doAnim() {
        $('div.stpAnim').each($).wait(<?php echo $interval_single; ?>, function(index){
         if ($.browser.msie) {
           $(this).wiggle('start', {
           limit: 5,
           randomStart: true, });
           } else {

            var animClass = $(this).children('span').attr('rel');
            $(this).addClass(animClass);
        var wait = window.setTimeout( function(){
            $('div.stpAnim').removeClass(animClass)},
            1300
        );
       }
      });
    }
                               
                setInterval(function() {   
                   doAnim();
                  }, <?php echo $delay_single; ?>);   

<?php } 
else if(stpv3MetaBox::get('stpv3_trigger') == 'exit') { 
 ?>

        function doAnim() {
        $('div.stpAnim').each($).wait(0, function(index){
         if ($.browser.msie) {
           $(this).wiggle('start', {
           limit: 5,
           randomStart: true, });
           } else {

            var animClass = $(this).children('span').attr('rel');
            $(this).stop().addClass(animClass);
        var wait = window.setTimeout( function(){
            $('div.stpAnim').stop().removeClass(animClass)},
            1300
        );
       } 
      });
    }
 
$(document).mousemove(function(e) {
      var topOff = $("html").scrollTop(); 
      if(e.pageY <= 30 + topOff) {
      doAnim();
      }
    }); 
<?php }
else if(stpv3MetaBox::get('stpv3_trigger') == 'content-trigger') { ?>
        function doAnim() {
        $('div.stpAnim').each($).wait(1, function(index){
          if ($.browser.msie) {
           $(this).wiggle('start', {
           limit: 5,
           randomStart: true, });
           } else {

            var animClass = $(this).children('span').attr('rel');
            $(this).addClass(animClass);
        var wait = window.setTimeout( function(){
            $('div.stpAnim').removeClass(animClass)},
            1300
        );
       }
      });
    }
    
    $('#trigger').waypoint(function() {
   doAnim() }, {
   offset: '<?php echo stpv3MetaBox::get('stpv3_content_trigger_threshold'); ?>%'
});
        
<?php } ?>
});
</script>
<?php
    } 
  }
}

function sorethumb_styles() {
if(!is_admin()){
   wp_enqueue_style('stpv3', SORETHUMB_URL . 'includes/css/stpv3.css');
      if(defined('PAK1')){
        wp_enqueue_style('stpv3pak', SORETHUMB_URL . 'includes/css/stpv3pak.css');       
      }    
    }
  }


function stpv3_admin_scripts() {
wp_enqueue_script('stpv3sw', SORETHUMB_URL . 'includes/js/stpv3sw.js', array('jquery'));
 } 

add_action('admin_menu', 'register_stpv3_menu_page');
function register_stpv3_menu_page() {
   add_menu_page('SoreThumb Settings', 'SoreThumb', 'manage_options', 'sorethumb/sorethumb.php', '',   plugins_url('sorethumb/includes/img/menu.png'), 27);
}

//add_action('wp_head', 'stpv3_conditionals');
add_action('wp_footer', 'sorethumb_footerscripts', 10);
add_action( "admin_print_scripts-post.php", 'stpv3_admin_scripts' );
add_action( "admin_print_scripts-post-new.php", 'stpv3_admin_scripts' );
add_action('wp_enqueue_scripts', 'sorethumb_scripts');
add_action('wp_enqueue_scripts', 'sorethumb_styles');


  function stlaser_add_query_vars($aVars) {

    $aVars[] = "laser"; // represents the classifier of the variable 

    return $aVars;

  }
  
  add_filter('query_vars', 'stlaser_add_query_vars');
  add_action('get_header', 'check_stlaser');
  
function check_stlaser() {

 if(!is_admin() && current_user_can('manage_options')) {
  global $wp_query;
      if(isset($wp_query->query_vars['laser'])) {
      $the_laser = urldecode($wp_query->query_vars['laser']);

        if($the_laser == 'activate'){
          wp_enqueue_style('lasertip', SORETHUMB_URL . 'includes/css/lasertip.css');
        wp_enqueue_script('jquery');
        wp_enqueue_script('jqtools', SORETHUMB_URL . 'includes/js/jquery.tools.min.js', array('jquery'));
        wp_enqueue_script('pagelaser', SORETHUMB_URL . 'includes/js/pagelaser.js', array('jquery'));

   }
  }
 }
}

add_action( 'admin_bar_menu', 'fire_laser', 999 );

function fire_laser( $wp_admin_bar ) {
if (!is_admin()) {
  global $wp_admin_bar;
  
$url = $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"]; 
$name = "laser";                        
$value = "activate";                          
 
$separator = "?";
if (strpos($url,"?")!=false)
  $separator = "&";
 
$newUrl = $url . $separator . "$name=$value";       

  $args = array(
    'id' => 'firelaser',
    'title' => 'Activate PageLaser',
    'href' => $newUrl
  );

  $wp_admin_bar->add_node($args);
 }
}

//////////////////////////////////////////////////////////////////////////////
// Updates
//////////////////////////////////////////////////////////////////////////////

define('DEBUG', false);

class WpPluginAutoUpdate {
    # URL to check for updates, this is where the index.php script goes
    public $api_url;

    # Type of package to be updated
    public $package_type;

    public $plugin_slug;
    public $plugin_file;

    public function WpPluginAutoUpdate($api_url, $type, $slug) {
        $this->api_url = $api_url;
        $this->package_type = $type;
        $this->plugin_slug = $slug;
        $this->plugin_file = $slug .'/'. $slug . '.php';
    }

    public function print_api_result() {
        print_r($res);
        return $res;
    }

    public function check_for_plugin_update($checked_data) {
        if (empty($checked_data->checked))
            return $checked_data;
        
        $request_args = array(
            'slug' => $this->plugin_slug,
            'version' => $checked_data->checked[$this->plugin_file],
            'package_type' => $this->package_type,
        );

        $request_string = $this->prepare_request('basic_check', $request_args);
        
        // Start checking for an update
        $raw_response = wp_remote_post($this->api_url, $request_string);

        if (!is_wp_error($raw_response) && ($raw_response['response']['code'] == 200)) {
            $response = unserialize($raw_response['body']);

            if (is_object($response) && !empty($response)) // Feed the update data into WP updater
                $checked_data->response[$this->plugin_file] = $response;
        }
        
        return $checked_data;
    }

    public function plugins_api_call($def, $action, $args) {
        if ($args->slug != $this->plugin_slug)
            return false;
        
        // Get the current version
        $plugin_info = get_site_transient('update_plugins');
        $current_version = $plugin_info->checked[$this->plugin_file];
        $args->version = $current_version;
        $args->package_type = $this->package_type;
        
        $request_string = $this->prepare_request($action, $args);
        
        $request = wp_remote_post($this->api_url, $request_string);
        
        if (is_wp_error($request)) {
            $res = new WP_Error('plugins_api_failed', __('An Unexpected HTTP Error occurred during the API request.</p> <p><a href="?" onclick="document.location.reload(); return false;">Try again</a>'), $request->get_error_message());
        } else {
            $res = unserialize($request['body']);
            
            if ($res === false)
                $res = new WP_Error('plugins_api_failed', __('An unknown error occurred'), $request['body']);
        }
        
        return $res;
    }

    public function prepare_request($action, $args) {
        $site_url = site_url();

        $wp_info = array(
            'site-url' => $site_url,
            'version' => $wp_version,
        );

        return array(
            'body' => array(
                'action' => $action, 'request' => serialize($args),
                'api-key' => md5($site_url),
                'wp-info' => serialize($wp_info),
            ),
            'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo('url')
        );
    }
}

$wp_plugin_auto_update = new WpPluginAutoUpdate('http://vertical3.com/svn/repo/', 'stable', basename(dirname(__FILE__)));

if (DEBUG) {
    // Enable update check on every request. Normally you don't need 
    // this! This is for testing only!
    set_site_transient('update_plugins', null);

    // Show which variables are being requested when query plugin API
    add_filter('plugins_api_result', array($wp_plugin_auto_update, 'print_api_result'), 10, 3);
}

// Take over the update check
add_filter('pre_set_site_transient_update_plugins', array($wp_plugin_auto_update, 'check_for_plugin_update'));

// Take over the Plugin info screen
add_filter('plugins_api', array($wp_plugin_auto_update, 'plugins_api_call'), 10, 3);



//////////////////////////////////////////////////////////////////////////////
// MCE
//////////////////////////////////////////////////////////////////////////////
function stpv3_mce_css( $mce_css ) {
	if ( ! empty( $mce_css ) )
		$mce_css .= ',';
	$mce_css .= plugins_url( 'stpv3admin.css', __FILE__ );
	return $mce_css;
}
function stpv3_addbuttons() {
   if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
     return;
   if ( get_user_option('rich_editing') == 'true') {
     add_filter("mce_external_plugins", "add_stpv3_buttons");
     add_filter('mce_buttons_3', 'register_stpv3_buttons');
   }
  }
function register_stpv3_buttons($buttons) {
   array_push($buttons, "stpv3_button_image", "stpv3slb2");
   return $buttons;
  }
function add_stpv3_buttons($plugin_array) {
  $plugin_array['stpv3_button_image'] = SORETHUMB_URL.'includes/js/tinymce/stpv3_button_image/editor_plugin.js';
if(defined('PAK1')){
  $plugin_array['stpv3slb2'] = SORETHUMB_URL.'includes/js/tinymce/stpv3slb2/editor_plugin_alt.js';
  }
  else{
  $plugin_array['stpv3slb2'] = SORETHUMB_URL.'includes/js/tinymce/stpv3slb2/editor_plugin.js';
  }
   return $plugin_array;
  }
if (is_admin()) {
add_action('init', 'stpv3_addbuttons');
add_filter( 'mce_css', 'stpv3_mce_css' );
}
//add_filter( 'mce_buttons_2', 'sorethumb_mce' );
//
//function sorethumb_mce( $buttons ) {
//    array_unshift( $buttons, 'styleselect' );
//    return $buttons;
//}
add_filter( 'tiny_mce_before_init', 'sorethumb_mce_styles' );
add_filter( 'tiny_mce_before_init', 'sorethumb_mce_attr' );

function sorethumb_mce_attr( $init ) {
    // Command separated string of extended elements
    $ext = 'span[align<center?justify?left?right|class|dir<ltr?rtl|id|lang|onclick|ondblclick|onkeydown|onkeypress|onkeyup|onmousedown|onmousemove|onmouseout|onmouseover|onmouseup|style|title|rel]';

    // Add to extended_valid_elements if it alreay exists
    if ( isset( $init['extended_valid_elements'] ) ) {
        $init['extended_valid_elements'] = $init['extended_valid_elements'] . ',' . $ext;
    } else {
        $init['extended_valid_elements'] = $ext;
    }

    // Super important: return $init!
    return $init;
}

function sorethumb_mce_styles( $settings ) {
global $pak_1b;
$formats = array(
        'tada' => array(
                         'inline' => 'span',
                         'classes' => 'stp',
                         'attributes' => array('rel' => 'tada')
                         ),
        'pulse' => array(
                         'inline' => 'span',
                         'classes' => 'stp',
                         'attributes' => array('rel' => 'pulse')
                         ),
        'flash' => array(
                         'inline' => 'span',
                         'classes' => 'stp',
                         'attributes' => array('rel' => 'flash')
                         ),
        'bounce' => array(
                         'inline' => 'span',
                         'classes' => 'stp',
                         'attributes' => array('rel' => 'bounce')
                         ),
        'shake' => array(
                         'inline' => 'span',
                         'classes' => 'stp',
                         'attributes' => array('rel' => 'shake')
                         ),
        'wobble' => array(
                         'inline' => 'span',
                         'classes' => 'stp',
                         'attributes' => array('rel' => 'wobble')
                         ),
        'swing' => array(
                         'inline' => 'span',
                         'classes' => 'stp',
                         'attributes' => array('rel' => 'swing')
                         ),                            
      'trigger' => array(
                         'inline' => 'span',
                         'attributes' => array('id' => 'trigger')
                         )                                                                                                                                                      
    );
  if(defined('PAK1')){
     $formats = $formats + $pak_1b;
    }
    
    $settings['formats'] = json_encode( $formats );
    return $settings;
}
//////////////////////////////////////////////////////////////////////////////
// Settings API
//////////////////////////////////////////////////////////////////////////////
// Set-up Action and Filter Hooks
register_activation_hook(__FILE__, 'stpv3_add_defaults');
register_uninstall_hook(__FILE__, 'stpv3_delete_plugin_options');
add_action('admin_init', 'stpv3_init' );
add_action('admin_menu', 'stpv3_add_options_page');
add_filter( 'plugin_action_links', 'stpv3_plugin_action_links', 10, 2 );
//Delete options table entries ONLY when plugin deactivated AND deleted
function stpv3_delete_plugin_options() {
	delete_option('stpv3_options');
}
// Define default option settings
function stpv3_add_defaults() {
	$tmp = get_option('stpv3_options');
    if(($tmp['chk_default_options_db']=='1')||(!is_array($tmp))) {
		delete_option('stpv3_options');
		$arr = array(
    'enable_sorethumb_site' => 'enabled',
    'site_delay' => '8000',
    'site_interval' => '0' );
		update_option('stpv3_options', $arr);
	}
}
function stpv3_init(){
	register_setting( 'stpv3_plugin_options', 'stpv3_options', 'stpv3_validate_options' );
}
function stpv3_add_options_page() {
	add_options_page('SoreThumb Settings', 'SoreThumb', 'manage_options', __FILE__, 'stpv3_render_form');
}
function stpv3_render_form() {
global $pak_1;
$pak_mu = array(
        'tada' => array(
                        'name' => 'Tada!',
                        'slug' => 'tada'
                         ),
        'pulse' => array(
                         'name' => 'Pulse',
                         'slug' => 'pulse'
                         ),
        'flash' => array(
                         'name' => 'Flash',
                         'slug' => 'flash'
                         ),
        'bounce' => array(
                         'name' => 'Bounce',
                         'slug' => 'bounce'
                         ),
        'shake' => array(
                         'name' => 'Shake',
                         'slug' => 'shake'
                         ),
        'wobble' => array(
                         'name' => 'Wobble',
                         'slug' => 'wobble'
                         ),
        'swing' => array(
                         'name' => 'Swing',
                         'slug' => 'swing'
                         )  
  );
  
  if(defined('PAK1')){
    $pak_mu = $pak_mu + $pak_1;
    }
    
	?>	
<div class="wrap">		 		
  <!-- Display Plugin Icon, Header, and Description --> 		
  <div class="icon32" id="icon-options-general">
    <br>
  </div>		<h2>SoreThumb Settings</h2>		
  <p>Please look over these simple settings and make changes if necessary to suit your needs.
  </p>		
 <!-- Beginning of the Plugin Options Form -->		
  <form method="post" action="options.php">			
    <?php settings_fields('stpv3_plugin_options'); ?>			
    <?php $options = get_option('stpv3_options'); ?>			
    <!-- Table Structure Containing Form Controls -->			
    <!-- Each Plugin Option Defined on a New Table Row -->			
    <table class="form-table">
    <!-- Radio Button Group -->				
      <tr valign="top">					
        <th scope="row"><b>Enable Site-Wide SoreThumb Elements</b>
        </th>					<td>					
          <!-- First radio button -->						
          <label>
            <input name="stpv3_options[enable_sorethumb_site]" type="radio" value="enabled" <?php checked('enabled', $options['enable_sorethumb_site']); ?> /> Enabled (recommended) 
          </label><br />						
          <!-- Second radio button -->						
          <label>
            <input name="stpv3_options[enable_sorethumb_site]" type="radio" value="disabled" <?php checked('disabled', $options['enable_sorethumb_site']); ?> /> Disabled 
          </label><br />					</td>				
      </tr>                                								
      <!-- Textbox Control -->				
      <tr>					
        <th scope="row"><b>Site Element 1</b>
        </th>					<td>						
          <input type="text" size="57" name="stpv3_options[site_element_1]" value="<?php echo $options['site_element_1']; ?>" /><br>
          <select name='stpv3_options[site_element_1_effect]'>
<?php   foreach($pak_mu as $pak_op) {
              echo "<option value='" . $pak_op['slug'] . "' " . selected($pak_op['slug'], $options['site_element_1_effect']) . ">" . $pak_op['name'] . "</option>";
              } ?>
						</select>                                                
          <br>Enter the element id (example #theid) or class (example .theclass) and choose the effect</td>				
      </tr>
       <tr>					
        <th scope="row"><b>Site Element 2</b>
        </th>					<td>						
          <input type="text" size="57" name="stpv3_options[site_element_2]" value="<?php echo $options['site_element_2']; ?>" /><br>
          <select name='stpv3_options[site_element_2_effect]'>
<?php   foreach($pak_mu as $pak_op) {
              echo "<option value='" . $pak_op['slug'] . "' " . selected($pak_op['slug'], $options['site_element_2_effect']) . ">" . $pak_op['name'] . "</option>";
              } ?>
						</select>                                                
          <br>Enter the element id (example #theid) or class (example .theclass) and choose the effect</td>				
      </tr>
            <tr>					
        <th scope="row"><b>Site Element 3</b>
        </th>					<td>						
          <input type="text" size="57" name="stpv3_options[site_element_3]" value="<?php echo $options['site_element_3']; ?>" /><br>
          <select name='stpv3_options[site_element_3_effect]'>
<?php   foreach($pak_mu as $pak_op) {
              echo "<option value='" . $pak_op['slug'] . "' " . selected($pak_op['slug'], $options['site_element_3_effect']) . ">" . $pak_op['name'] . "</option>";
              } ?>
						</select>                                                
          <br>Enter the element id (example #theid) or class (example .theclass) and choose the effect</td>				
      </tr>
            <!-- Textbox Control -->				
      <tr>					
        <th scope="row"><b>Site Elements Delay</b>
        </th>					<td>						
          <input type="text" size="57" name="stpv3_options[site_delay]" value="<?php echo $options['site_delay']; ?>" />
          <br>Enter the initial delay in milliseconds (ie. 6 seconds = 6000), this will also be the master interval for the entire effect loop.</td>				
      </tr>
                  <!-- Textbox Control -->				
      <tr>					
        <th scope="row"><b>Site Elements Interval</b>
        </th>					<td>						
          <input type="text" size="57" name="stpv3_options[site_interval]" value="<?php echo $options['site_interval']; ?>" />
          <br>Time in milliseconds between animation of each element. For an even rotation, divide your initial delay by the number of elements and subtract 300-500. If you only have one active SoreThumb site element, leave this at 0.</td>				
      </tr>
      <!-- End of Form Fields -->                     				
      <tr>
        <td colspan="2">
          <div style="margin-top:10px;">
          </div></td>
      </tr>				
      <tr valign="top" style="border-top:#dddddd 1px solid;">				
      </tr>			
    </table>			
    <p class="submit">			
      <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />			
    </p><h2>Need Support?</h2>
    Head over to the help desk where you can see the Frequently Asked Questions,<br> learn some Tips and Tricks, or Submit a Support Ticket.
    <br><br><span style="margin-left:10px;"><b>>> <a href="http://help.sore-thumb.net/" target="_blank"> Take Me To The Help Desk.</a></b></span>		
  </form>	
</div>			

<?php	
}
// Sanitize and validate input. Accepts an array, return a sanitized array.
function stpv3_validate_options($input) {
	 // strip html from textboxes
	$input['textarea_one'] =  wp_filter_nohtml_kses($input['textarea_one']); // Sanitize textarea input (strip html tags, and escape characters)
	$input['txt_one'] =  wp_filter_nohtml_kses($input['txt_one']); // Sanitize textbox input (strip html tags, and escape characters)
	return $input;
}
// Display a Settings link on the main Plugins page
function stpv3_plugin_action_links( $links, $file ) {
	if ( $file == plugin_basename( __FILE__ ) ) {
		$stpv3_links = '<a href="'.get_admin_url().'options-general.php?page=sorethumb/sorethumb.php">'.__('Settings').'</a>';
		// make the 'Settings' link appear first
		array_unshift( $links, $stpv3_links );
	}
	return $links;
}
//////////////////////////////////////////////////////////////////
// MetaBoxes
//////////////////////////////////////////////////////////////////
  		add_stpv3_meta_box('stpv3_meta', array(
	    'title' => 'SoreThumb', // the title of the meta box
	    'pages' => array('post', 'page'),  // post types on which you want the metabox to appear
	    'context' => 'normal', // meta box context (see above)
	    'priority' => 'high', // meta box priority (see above)
	    'fields' => array( // array describing our fields
          array(
	            'name' => '<b>Note:</b>',
	            'id' => 'stpv3_note',
                    'type' => 'none',
                    'desc' => '<b>We recommend that you only apply SoreThumb to a few elements within the content for maximum effect, a little goes a long way!</b>'
	        ),              
	        array(
	            'name' => 'Enable SoreThumb?',
	            'id' => 'stpv3_activate',
	            'type' => 'checkbox', // options are checkbox, image, radio, select, text, textarea
              'desc' => 'Enables SoreThumb when this post/page is displayed.',
              'default' => true
	        ),
          array(
	            'name' => 'Trigger',
	            'id' => 'stpv3_trigger',
              'default' => 'delay',
	            'type' => 'radio', // options are checkbox, image, radio, select, text, textarea
                    'options' => array(
                          'delay' => 'Delay',
                          'content-trigger' => 'In-Content Trigger',
                          'exit' => '"Exit" Trigger'),
                    'desc' => '<br><b>Delay:</b> Fires and repeats after a defined time, if you apply SoreThumb to multiple elements you can also set a rotation interval.<br><b>In-Content:</b> Fires once the trigger element is scrolled into view<br><b>"Exit":</b> Fires when the user\'s mouse crosses the upper portion of the window<br>',
               ),
          array(
	            'name' => 'Initial Delay/Interval',
	            'id' => 'stpv3_delay',
              'default' =>  '5000',
	            'type' => 'text', // options are checkbox, image, radio, select, text, textarea
              'desc' => '<br>Enter the initial delay in milliseconds (ie. 6 seconds = 6000), this will also be the interval for the entire effect loop.',
	        ),  
          array(
	            'name' => 'Rotation Interval',
	            'id' => 'stpv3_interval',
              'default' =>  '0',
	            'type' => 'text', // options are checkbox, image, radio, select, text, textarea
              'desc' => '<br>Time in milliseconds between animation of each element. If you only have one SoreThumb element in the content, leave at 0.',
	        ),
          array(
	            'name' => '<b>In-Content Trigger</b>',
	            'id' => 'stpv3_content_trigger_note',
                    'type' => 'none',
                    'desc' => 'Select any element or text in the editor and use the Crosshair tool to set it as the trigger',
	        ),
          array(
	            'name' => '<b>Threshold</b>',
	            'id' => 'stpv3_content_trigger_threshold',
              'type' => 'select',
                'options' => array(
                        '2' => 'Top of View',
                        '50' => 'Middle of View',
                        '98' => 'Bottom of View'),
              'desc' => 'The trigger fires when it crosses this point in the view. When scrolling downward, Bottom of View fires first, Top of View last.'
	        ),
          array(
	            'name' => '<b>Exit Trigger:</b>',
	            'id' => 'stpv3_exit_trigger_note',
                    'type' => 'none',
                    'desc' => 'Keep in mind that your visitors will not be able to see the element if it has been scrolled out of view',
	        ),          
	    )
	));