<?php

add_action( 'admin_menu', 'imwb_videopress_video_sitemap_add_page' );

function imwb_videopress_video_sitemap_add_page() {

   $page = add_submenu_page ('tools.php', __('Video Sitemap'), __('Video Sitemap'),
    'manage_options', 'imwb_videopress_video-sitemap-page', 'imwb_videopress_video_sitemap');
    
   /* Using registered $page handle to hook stylesheet loading */
   add_action( 'admin_print_styles-' . $page, 'imwb_videopress_admin_styles' );
   add_action( 'admin_print_scripts-' . $page, 'imwb_videopress_admin_scripts' );    
 }
    
function imwb_videopress_video_sitemap() {
?>

<div class="wrap">
<div id="imwb_plugin_header">
<a href="http://imwealthbuilders.com" target="_blank"><img src="<?php echo get_template_directory_uri(). '/images/imwblogo.png';?>"></a>
<span id="imwb_plugin_header_link"><a href="http://imwealthbuilders.com/newplugins" target="_blank">Click Here To See Our Latest WP Plugins</a></span>
<h2>Covert VideoPress Theme</h2>
<div style="clear: both"></div>
</div>

<div id="imwb_plugin_options_editor">
	
	<?php screen_icon(); echo "<h2>" . __( 'XML Video Sitemap', 'imwb_videopress' ) . ' - <small><a href="http://covertvideopress.com/help/std_help.html" target="_blank">Click Here For Help</a></small></h2>'; ?>
<?php
if(isset($_REQUEST['submit'])) {

   echo '<div class="imwb_cabar_active_panel">';
   
   // Generate the sitemap
   $result = imwb_videopress_video_sitemap_generate(isset($_REQUEST['imwb_videopress_inc_rating']),isset($_REQUEST['imwb_videopress_inc_views']));
?>
<?php echo $result; ?>
</div>
<?php

}
?>	
	
  <p>Video Sitemaps are used to tell search engines about the video content on your site. During regular crawling, search engines mostly ignore video content that’s embedded in web pages but with the help of a video sitemap, you can easily inform them about the videos that are on your site. </p>
  <p>Click the button below to generate a video sitemap for your site.</p>
<form method="post" action="" enctype="multipart/form-data">
<p>Include Video Ratings: <input type=checkbox name="imwb_videopress_inc_rating" checked></p>
<p>Include Video View Count: <input type=checkbox name="imwb_videopress_inc_views" checked></p>
<input type="submit" name="submit" class="button-primary" value="<?php _e( 'Generate Video Sitemap', 'imwb_videopress' ); ?>" />
</form>
</div>
</div>
<?php
}


function imwb_videopress_video_sitemap_generate($inc_rating, $inc_views) {
   global $wpdb;

   $posts = $wpdb->get_results ("SELECT id, post_title, post_content, post_date_gmt, post_excerpt FROM $wpdb->posts WHERE post_status = 'publish' AND (post_type = 'post' OR post_type = 'page') ORDER BY post_date DESC");
       
   if (empty ($posts)) 
      return '<p>Looks like none of your blog posts contain videos.</p>';
      
   $xml  = '<?xml version="1.0" encoding="UTF-8"?>' . "\n";       
   $xml .= '<!-- Created by http://covertvideopress.com -->' . "\n";
   $xml .= '<!-- Generated-on="' . date("F j, Y, g:i a") .'" -->' . "\n";                   
   $xml .= '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" xmlns:video="http://www.google.com/schemas/sitemap-video/1.1"> ' . "\n";
   
   $video_ids = array();
   
   foreach ($posts as $post) {
   
      // See if post is a CVC generated one
      $video_type = get_post_meta( $post->id, 'imwb_videopress_post_video_type', true );
      $video_url = get_post_meta( $post->id, 'imwb_videopress_post_video_url', true );
      $video_thumb = imwb_videopress_post_thumbnail_img_src( $post->id);
      
      if(empty($video_url))
         continue;
      
      $video_id = imwb_videopress_get_video_id($video_type, $video_url);
      if (in_array($video_id, $video_ids))
          continue;
          
      array_push($video_ids, $video_id);
   
      $title = substr(get_the_title($post->id), 0, 100);
      
      if($post->post_excerpt != "") 
          $excerpt = $post->post_excerpt;
      else {
          $excerpt = $post->post_content ;    
          $excerpt = apply_filters('imwb_videopress_filter_content', $excerpt, '' );
          $excerpt = imwb_videopress_strip_video_shortcodes($excerpt);
          $excerpt = apply_filters('the_content', $excerpt);
          $excerpt = str_replace(']]>', ']]&gt;', $excerpt);
          $excerpt = substr(imwb_videopress_strip_embed_code($excerpt),0,2048);
      }
      
      $permalink = get_permalink($post->id); 
      
      $xml .= "\n <url>\n";
      $xml .= " <loc>$permalink</loc>\n";
      $xml .= " <video:video>\n";
      $xml .= "  <video:thumbnail_loc>".$video_thumb."</video:thumbnail_loc>\n";
      $xml .= "  <video:title>" . htmlspecialchars($title). "</video:title>\n";
      $xml .= "  <video:description>" . htmlspecialchars($excerpt) . "</video:description>\n";
      
      switch($video_type){
         case 'D':   $xml .= "  <video:player_loc allow_embed=\"yes\" autoplay=\"autoPlay=".imwb_videopress_get_option('autoplay')."\">http://www.dailymotion.com/swf/$video_id</video:player_loc>\n";
                     break;
      	case 'F':   $xml .= "  <video:content_loc>".$video_url."</video:content_loc>\n";
      		         break;
         case 'M':   $xml .= "  <video:player_loc allow_embed=\"yes\" autoplay=\"autoPlay=".(imwb_videopress_get_option('autoplay') == '0' ? 'no' : 'yes')."\">http://www.metacafe.com/fplayer/$video_id/imwb_videopress_player.swf</video:player_loc>\n";
       	            break;     		
      	case 'Y':   $xml .= "  <video:player_loc allow_embed=\"yes\" autoplay=\"autoplay=".imwb_videopress_get_option('autoplay')."\">http://www.youtube.com/v/$video_id</video:player_loc>\n";
      	            $duration = imwb_videopress_youtube_duration ($video_id);
      	            if ($duration != 0)
      	              $xml .= "  <video:duration>".$duration."</video:duration>\n";
                     break;
         case 'V':   $xml .= "  <video:player_loc allow_embed=\"yes\" autoplay=\"autoplay=".imwb_videopress_get_option('autoplay')."\">http://www.vimeo.com/moogaloop.swf?clip_id=$video_id</video:player_loc>\n";
                  	break;
      } 


      if($inc_rating) 
         $rating = imwb_videopress_get_rating($post->id);
         if($rating >0 and $rating <=5)
            $xml .= "  <video:rating>".number_format($rating,1)."</video:rating>\n";
         
      if($inc_views) {
         $view_count = get_post_meta($post->id, '_imwb_videopress_post_video_views', true );
         if(!empty($view_count))
            $xml .= "  <video:view_count>".$view_count."</video:view_count>\n";
      }
      
      $xml .= "  <video:publication_date>".date (DATE_W3C, strtotime ($post->post_date_gmt))."</video:publication_date>\n";

      $posttags = get_the_tags($post->id); if ($posttags) { 
      $tagcount=0;
      foreach ($posttags as $tag) {
         if ($tagcount++ > 32) break;
         $xml .= "   <video:tag>$tag->name</video:tag>\n";
         }
      }    
      
      $postcats = get_the_category($post->id); if ($postcats) { 
      foreach ($postcats as $category) {
         $xml .= "   <video:category>$category->name</video:category>\n";
         break;
         }
      }        
      
      $xml .= " </video:video>\n </url>";   
   }
   
   $xml .= "\n</urlset>";
   
   // Try and save the video sitemap
   $video_sitemap_url = $_SERVER["DOCUMENT_ROOT"] . '/sitemap-video.xml';
   if (is_file_writable($_SERVER["DOCUMENT_ROOT"]) || is_file_writable($video_sitemap_url)) {
       if (file_put_contents ($video_sitemap_url, $xml)) {
       
          $sitemapurl = get_bloginfo('url') . "/sitemap-video.xml"; 
           return '<p>The <a target="_blank" href="'.$sitemapurl.'">XML Video Sitemap</a> was generated successfully and you can <a target="_blank" href="http://www.google.com/webmasters/sitemaps/ping?sitemap='.$sitemapurl.'">inform Google</a> about your updated video sitemap.</p>';
       }
   } 
   
   echo '<h2>Error writing the file</h2><p>The XML sitemap was generated successfully but was unable to save the xml to your WordPress root folder at <strong>' . $_SERVER["DOCUMENT_ROOT"] . '</strong> most likely the folder doesn\'t have appropriate <a href="http://codex.wordpress.org/Changing_File_Permissions" target="_blank">write permissions</a>.</p><p>You can manually copy-paste the following text into a file and save it as video-sitemap.xml in your WordPress root folder. </p><textarea rows="30" cols="150" style="font-family:verdana; font-size:11px;color:#666;background-color:#f9f9f9;padding:5px;margin:5px">' . $xml . '</textarea>';    
   
   return;
}

function is_file_writable($filename) {

   if(!is_writable($filename)) {
      // Not writable.
      if(!@chmod($filename, 0666)) {
         $pathname = dirname($filename);
         // Is parent directory writable.
         if(!is_writable($pathname)) {
           // Not writeable
           if(!@chmod($pathname, 0666)) {
              return false;
           }
        }
      }
   }

   return true;
}

function imwb_videopress_youtube_duration ($video_id) {

   $response = wp_remote_get( 'http://gdata.youtube.com/feeds/api/videos/' . $video_id);
   if( is_wp_error( $response ) ) 
      return 0;
           
   preg_match ("/duration=['\"]([0-9]*)['\"]/", $response['body'], $match);
   if(isset($match [1]))
      return $match [1];     
      
   return 0;
      
    try {
        $ch = curl_init ();
        curl_setopt ($ch, CURLOPT_URL, "http://gdata.youtube.com/feeds/api/videos/$id");
        curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
        $data = curl_exec ($ch);
        curl_close ($ch);

        preg_match ("/duration=['\"]([0-9]*)['\"]/", $data, $match);
        return $match [1];

    } catch (Exception $e) {
        # returning 0 if the YouTube API fails for some reason.
        return '0';
    }
}
?>